/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: syslog.h 837 2012-12-26 15:09:59Z ertl-hiro $
 */

/*
 *		ƥǽ
 */

#ifndef TOPPERS_SYSLOG_H
#define TOPPERS_SYSLOG_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  ƥϤԤ
 */
#include <t_syslog.h>
#include <extsvc_fncode.h>
#include "target_syssvc.h"

/*
 *  ХåեȤ˥뤿Υݥ
 */
#ifndef TCNT_SYSLOG_BUFFER
#define TCNT_SYSLOG_BUFFER	32		/* ХåեΥ */
#endif /* TCNT_SYSLOG_BUFFER */

/*
 *  ƥǽγĥӥΥå
 */ 
#ifndef SSZ_SYSLOG_WRI_LOG
#define SSZ_SYSLOG_WRI_LOG	1024
#endif /* SSZ_SYSLOG_WRI_LOG */

#ifndef SSZ_SYSLOG_REA_LOG
#define SSZ_SYSLOG_REA_LOG	1024
#endif /* SSZ_SYSLOG_REA_LOG */

#ifndef SSZ_SYSLOG_MSK_LOG
#define SSZ_SYSLOG_MSK_LOG	1024
#endif /* SSZ_SYSLOG_MSK_LOG */

#ifndef SSZ_SYSLOG_REF_LOG
#define SSZ_SYSLOG_REF_LOG	1024
#endif /* SSZ_SYSLOG_REF_LOG */

/*
 *  ƥǽν
 */
extern void	syslog_initialize(intptr_t exinf) throw();

/*
 *  ƥǽγĥӥˤƽФ󥿥ե
 */
#ifndef TOPPERS_SVC_CALL

/*
 *  ν
 *
 *  TOPPERS_OMIT_SYSLOGƤʤ硤syslog_wri_log
 *  syslog_fwri_logϡt_syslog.h뤿ᡤǤʤ
 */
#ifdef TOPPERS_OMIT_SYSLOG

Inline ER
syslog_wri_log(uint_t prio, const SYSLOG *p_syslog)
{
	return((ER) cal_svc(TFN_SYSLOG_WRI_LOG, (intptr_t) prio,
										(intptr_t) p_syslog, 0, 0, 0));
}

Inline ER
syslog_fwri_log(ER ercd, const SYSLOG *p_syslog)
{
	return((ER) cal_svc(TFN_SYSLOG_WRI_LOG, (intptr_t) ercd,
										(intptr_t) p_syslog, 0, 0, 0));
}

#endif /* TOPPERS_OMIT_SYSLOG */

/*
 *  ХåեΥɽФ
 */
Inline ER_UINT
syslog_rea_log(SYSLOG *p_syslog)
{
	return(cal_svc(TFN_SYSLOG_REA_LOG, (intptr_t) p_syslog, 0, 0, 0, 0));
}

/* 
 *  Ϥ٤ν٤
 */
Inline ER_UINT
syslog_msk_log(intptr_t logmask, intptr_t lowmask)
{
	return(cal_svc(TFN_SYSLOG_MSK_LOG, (intptr_t) logmask,
											(intptr_t) lowmask, 0, 0, 0));
}

/* 
 *  Хåեξֻ
 */
Inline ER_UINT
syslog_ref_log(intptr_t pk_rlog)
{
	return(cal_svc(TFN_SYSLOG_REF_LOG, (intptr_t) pk_rlog, 0, 0, 0, 0));
}

#endif /* TOPPERS_SVC_CALL */

/*
 *  ƥǽδؿƽФˤƽФ󥿥ե
 */
extern ER		_syslog_syslog_wri_log(uint_t prio,
										const SYSLOG *p_syslog) throw();
extern ER		_syslog_syslog_fwri_log(ER ercd,
										const SYSLOG *p_syslog) throw();
extern ER_UINT	_syslog_syslog_rea_log(SYSLOG *p_syslog) throw();
extern ER		_syslog_syslog_msk_log(uint_t logmask, uint_t lowmask) throw();
extern ER		_syslog_syslog_ref_log(T_SYSLOG_RLOG *pk_rlog) throw();

#ifdef TOPPERS_SVC_CALL
#define syslog_wri_log	_syslog_syslog_wri_log
#define syslog_fwri_log	_syslog_syslog_fwri_log
#define syslog_rea_log	_syslog_syslog_rea_log
#define syslog_msk_log	_syslog_syslog_msk_log
#define syslog_ref_log	_syslog_syslog_ref_log
#endif /* TOPPERS_SVC_CALL */

/*
 *  ƥǽĥӥȤϿ뤿
 */
extern ER_UINT	extsvc_syslog_wri_log(intptr_t prio, intptr_t p_syslog,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_syslog_fwri_log(intptr_t ercd, intptr_t p_syslog,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_syslog_rea_log(intptr_t p_syslog, intptr_t par2,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_syslog_msk_log(intptr_t logmask, intptr_t lowmask,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();
extern ER_UINT	extsvc_syslog_ref_log(intptr_t pk_rlog, intptr_t par2,
									intptr_t par3, intptr_t par4,
									intptr_t par5, ID cdmid) throw();

#ifdef __cplusplus
}
#endif

#endif /* TOPPERS_SYSLOG_H */
