/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel  
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: apsh4.h 1598 2009-06-29 09:43:33Z ertl-honda $
 */

/*
 *  APSH4 CPUܡɤΤΥϡɥ񸻤
 */

#ifndef TOPPERS_SOISOC_H
#define TOPPERS_SOISOC_H

#include <sil.h>

/*
 *  ץåΥϡɥ񸻤Υ󥯥롼
 */
#include "sh34_gcc/sh7750r.h"

/*
 *  ¢եå P = 30MHz
 */
#define	PCLOCK			30000000

/*
 *  DDRƬɥ쥹
 */
#define	DDR_BASE_ADDR	0x0c000000

/*
 *  DDRϢΥ쥸
 */
#define DDR_DMWR_B	0xfe800604		/* dummy write for big endian */
#define DDR_DMWR_L	0xfe800600		/* dummy write for little endian */
#define DDR_SDMR1	0xFEC02000		/* EMRS reg : DLL enable - BA0:1,A1=A0=0 */
#define DDR_SDMR2	0xFEC00b08		/* MRS  reg : BurtsLength=2,BurstSequence=Sequencial,CL=2.5,DLL=reset */
#define DDR_SDMR3	0xFEC00308		/* MRS  reg : BurtsLength=2,BurstSequence=Sequencial,CL=2.5,DLL=mormal */

#define DDRIF_MIM_H	0xFE800008		/* DDRIF MIM register */
#define DDRIF_MIM_L	0xFE80000c		/* DDRIF MIM register */
#define DDRIF_SDR_H	0xFE800030		/* DDRIF SDR register */
#define DDRIF_SDR_L	0xFE800034		/* DDRIF SDR register */
#define DDRIF_STR_H	0xFE800018		/* DDRIF STR register */
#define DDRIF_STR_L	0xFE80001c		/* DDRIF STR register */
#define DDRIF_SCR_H	0xFE800010		/* DDRIF SCR register */
#define DDRIF_SCR_L	0xFE800014		/* DDRIF SCR register */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ȯĶ¸ν
 */
Inline void
soisoc_exit(void)
{
    uint32_t sr = 0x10000000U;
    
    /*
     * Ū˥ꥻåȤȯ
     */
    /*
     * BLӥåȤΩƤ
     */
    Asm("ldc %0, sr" : : "r"(sr) );
    
    /*
     * 㳰
     */
    *((volatile int *) 0xFFFFFEC1U) = 0;
} 
#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_SOISOC_H */
