/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

/*
 *	MMUɥ饤СSH7750Rѡ
 */

#include "kernel_impl.h"
#include "task.h"
#include "memory.h"
#include <sil.h>
#include "kernel_cfg.h"
#include "target_mmu.h"

extern char _vector_start;
extern char _vector_end;
extern char _vector_entry_start;
extern char _vector_entry_end;

// ̿TLBݸȿ㳰ǡTLBݸȿɽФ㳰
void
target_rxtlb_violation_handler(void *p_excinf)
{
    uint32_t addr;
    Asm("stc spc, %0\n\t" : "=r"(addr));
    syslog(LOG_EMERG, "Memory access violation (rx) is occured at 0x%x.", addr);
    while(1);
}

// ǡTLBݸȿʽߡ㳰
void
target_wtlb_violation_handler(void *p_excinf)
{
    uint32_t addr;
    Asm("stc spc, %0\n\t" : "=r"(addr));
    syslog(LOG_EMERG, "Memory access violation (w) is occured at 0x%x.", addr);
    while(1);
}

// ڡ㳰
void
target_iwr_page_handler(void *p_excinf)
{
    syslog(LOG_EMERG, "TLB entry's dirty bit is false.");
    while(1);
}

// 㳰¹Գϻåϥɥ
void
target_emulate_texrtn_handler(void *p_excinf)
{
    syslog(LOG_EMERG, "User stack is no space at prepare texrtn.");
    while(1);
}

// 㳰꥿åϥɥ
void
target_emulate_ret_tex_handler(void *p_excinf)
{
    syslog(LOG_EMERG, "User stack is no space at return texrtn.");
    while(1);
}

// 롼 
void
target_mmu_initialize(void)
{
    /*
     *  ߤASID򥫡ͥɥᥤѡ0ˤ˥åȤ
     */
    sil_wrw_mem((void *)(MMU_PTEH), (uint32_t)((TASID_KERNEL) << (MMU_PTEH_ASID_BIT)));

    /*
     *  ڡơ֥Υ١ɥ쥹memtop_tableȤ
     */
    sil_wrw_mem((void *)(MMU_TTB), (uint32_t)(_kernel_memtop_table));

    /*
     *  MMU쥸
     *  LRUI = 0: ϤؤITLBȥ3
     *  URB = 0: ٤ƤΥȥ꤬ؤо
     *  URC = 0: ؤUTLBȥΥͤ0˽
     *  SQMD = 1: ȥ塼ΰؤΥø⡼ɤΤ
     *  SV = 0: ¿Ų۵⡼
     *          ¿Ų۵⡼ɤȤΤϡۤʤɥᥤ
     *          ˤäTLB˺ܤäƱڡASIDΥȥ
     *          ø⡼ɤǥ뤳Ȥ뤿Ǥ
     *  TI = 1: TLBեå夹
     *  AT = 1: MMUͭˤ
     */
    sil_wrw_mem((void *)(MMUCR), (uint32_t)(MMUCR_SQMD_PM | MMUCR_TI | MMUCR_AT));

    /*
     *  ǰΤᡤ8̿ʬԤ
     */
    Asm(
        "nop\n\t"
        "nop\n\t"
        "nop\n\t"
        "nop\n\t"
        "nop\n\t"
        "nop\n\t"
        "nop\n\t"
        "nop\n\t"
        :::"memory"
       );

    /*
     *  åѡ
     */
    //sil_wrw_mem((void *)(CCR), (uint32_t)(CCR_DISABLE));
    //sil_wrw_mem((void *)(CCR), (uint32_t)(CCR_MODE));

}

