/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

/*
 *	MMUɥ饤СSH7750Rѡ
 */

#ifndef TOPPERS_TARGET_MMU_H
#define TOPPERS_TARGET_MMU_H

/*
 *  ڡơ֥륨ȥ̥쥸PTEH
 *  [VPN 31:10] - - [ASID 7:0]
 */
#define MMU_PTEH 0xff000000 /* ڡơ֥륨ȥ̥쥸 */
#define MMU_PTEH_VPN_MASK 0xfffffc00 /* ۥڡֹΥޥ */
#define MMU_PTEH_VPN_BIT  10         /* ۥڡֹΥӥåȰ */
#define MMU_PTEH_ASID_MASK 0x0000000f /* ASIDΥޥ */
#define MMU_PTEH_ASID_BIT  0          /* ASIDΥӥåȰ */

/*
 *  ڡơ֥륨ȥ겼̥쥸PTEL
 *  - - - [PPN 28:10] - V SZ [PR 6:5] SZ C D SH WT
 */
#define MMU_PTEL 0xff000004 /* ڡơ֥륨ȥ겼̥쥸 */
#define MMU_PTEL_SH 0x00000002 /* ֥ͭӥå */
    /*
     *  0/1ʣΥץǥڡͭʤ/
     *  >> SH϶ͭɥᥤʤ1ǡʳʤ0
     *  >> SH1ȡTLBΥɥ쥹ӻASIDȤʤ
     */
#define MMU_PTEL_SZ_1K  0x00000000 /* ڡӥå:1K */
#define MMU_PTEL_SZ_4K  0x00000010 /* ڡӥå:4K */
#define MMU_PTEL_SZ_64K 0x00000080 /* ڡӥå:64K */
#define MMU_PTEL_SZ_1M  0x00000090 /* ڡӥå:1M */
#define MMU_PTEL_V 0x00000080 /* ͭӥå */
#define MMU_PTEL_PPN_MASK 0x1ffffe00 /* ʪڡֹΥޥ */
#define MMU_PTEL_PPN_BIT  10         /* ʪڡֹΥӥåȰ */
    /* 
     *  ʪɥ쥹ξ22ӥå
     *   Υ˥
     */
#define MMU_PTEL_PR_PRX     0x00000000 /* ݸǡ:ø⡼RX */
#define MMU_PTEL_PR_PRWX    0x00000020 /* ݸǡ:ø⡼RWX */
#define MMU_PTEL_PR_URX     0x00000040 /* ݸǡ:桼⡼RX */
#define MMU_PTEL_PR_URWX    0x00000060 /* ݸǡ:桼⡼RWX */
#define MMU_PTEL_C 0x00000008   /* å󥰲ǽӥå */
#define MMU_PTEL_D 0x00000004   /* ƥӥå */
#define MMU_PTEL_WT 0x00000001  /* 饤ȥ롼ӥå */

/*
 *  ڡơ֥륨ȥꥢ󥹥쥸PTEA
 *  [- 31:4] TC SA
 */
#define MMU_PTEA 0xff000034 /* ڡơ֥륨ȥꥢ󥹥쥸 */

/*
 *  Ѵơ֥١쥸TTB
 *  [TTB 31:0]
 *  ڡơ֥Υ١ɥ쥹
 */
#define MMU_TTB 0xff000008 /* Ѵơ֥١쥸 */

/*
 *  TLB㳰ɥ쥹쥸TEA
 *  [ADDR 31:0]
 *  MMU㳰ɥ쥹顼㳰ȯۥɥ쥹
 */
#define MMU_TEA 0xff00000c /* TLB㳰ɥ쥹쥸 */

/*
 *  MMU쥸MMUCR
 *  [LRUI 31:26] - - [URB 23:18] - - [URC 15:10] SQMD SV [- 7:3] TI - AT
 *  MMUCRν񤭴ϡP1P2ΰǹԤ
 *  MMUCR򹹿塢P0P3U0ȥ塼ΰ˥ǡȤϡ4֤̿˶
 *  MMUCR򹹿塢P0P3U0ΰʬȤϡ8֤̿˶
 */
#define MMUCR 0xff000010 /* MMU쥸 */
#define MMUCR_SQMD_UM 0x00000000 /* ȥ塼⡼ɥӥå: 桼⡼ɤǥǽ */
#define MMUCR_SQMD_PM 0x00000200 /* ȥ塼⡼ɥӥå: ø⡼ɤǤΤߥǽ */
#define MMUCR_SV 0x00000100 /* ۵⡼ɤڤؤӥå */
    /* 
     *  0¿Ų۵⡼ɡ1ñ첾۵⡼
     *  SVѹȤϡTI1
     */
#define MMUCR_TI 0x00000004 /* TLB̵ӥåȡ1񤯤TLBեå夹 */
#define MMUCR_AT 0x00000001 /* ɥ쥹Ѵͭӥå */
#define MMUCR_LRUI_MASK 0xfc000000 /* ؤITLBȥΥޥ */
#define MMUCR_LRUI_BIT  26         /* ؤITLBȥΥӥåȰ */
#define MMUCR_URB_MASK 0x00fc0000 /* ؤUTLBȥ궭Υޥ */
#define MMUCR_URB_BIT  18         /* ؤUTLBȥ궭ΥӥåȰ */
#define MMUCR_URC_MASK 0x0000fc00 /* ؤUTLBȥΥޥ */
#define MMUCR_URC_BIT  10         /* ؤUTLBȥΥӥåȰ */

/*
 *  㳰ֹ
 */
// ̿TLBݸȿ㳰ǡTLBݸȿɽФ㳰
#define EXCNO_RXTLB_PRT     0x0A0
// ǡTLBݸȿʽߡ㳰
#define EXCNO_WTLB_PRT      0x0C0
// ڡ㳰
#define EXCNO_IWR_PAGE      0x080
// 㳰¹Գϻåϥɥ
#define EXCNO_EMU_TEXRTN    0x200
// 㳰꥿åϥɥ
#define EXCNO_EMU_RET_TEX   0x220

/*
 *  ASIDѴޥ
 *  ͥɥᥤ: 0
 *  桼ɥᥤ: ɥᥤID
 */
#define TASID_KERNEL 0
#define TASID(domid) domid

#ifndef TOPPERS_MACRO_ONLY
// ̿TLBߥ㳰ǡTLBߥɽФ㳰
extern void target_rxtlb_miss_handler(void *p_excinf);
// ̿TLBݸȿ㳰ǡTLBݸȿɽФ㳰
extern void target_rxtlb_violation_handler(void *p_excinf);
// ǡTLBߥʽߡ㳰
extern void target_wtlb_miss_handler(void *p_excinf);
// ǡTLBݸȿʽߡ㳰
extern void target_wtlb_violation_handler(void *p_excinf);
// ڡ㳰
extern void target_iwr_page_handler(void *p_excinf);
// 롼 
extern void target_mmu_initialize(void) __attribute__((section(".text_uc")));
// 㳰¹Գϻåϥɥ
extern void target_emulate_texrtn_handler(void *p_excinf);
// 㳰꥿åϥɥ
extern void target_emulate_ret_tex_handler(void *p_excinf);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_MMU_H */
